/// <reference types="lodash" />
import React, { Component } from 'react';
import PropTypes from 'prop-types';
import shouldPureComponentUpdate from 'react-pure-render/function';
import { StylingFunction } from 'react-base16-styling';
import { Action } from 'redux';
declare const BUTTON_SKIP = "Skip";
declare const BUTTON_JUMP = "Jump";
declare type Button = typeof BUTTON_SKIP | typeof BUTTON_JUMP;
interface Props<A extends Action<unknown>> {
    styling: StylingFunction;
    isSelected: boolean;
    action: A;
    actionId: number;
    isInitAction: boolean;
    onSelect: React.MouseEventHandler<HTMLDivElement> | undefined;
    timestamps: {
        current: number;
        previous: number;
    };
    isSkipped: boolean;
    isInFuture: boolean;
    hideActionButtons: boolean | undefined;
    onToggleClick: () => void;
    onJumpClick: () => void;
    onCommitClick: () => void;
}
interface State {
    hover: boolean;
}
export default class ActionListRow<A extends Action<unknown>> extends Component<Props<A>, State> {
    state: {
        hover: boolean;
    };
    static propTypes: {
        styling: PropTypes.Validator<(...args: any[]) => any>;
        isSelected: PropTypes.Validator<boolean>;
        action: PropTypes.Validator<object>;
        isInFuture: PropTypes.Validator<boolean>;
        isInitAction: PropTypes.Validator<boolean>;
        onSelect: PropTypes.Validator<(...args: any[]) => any>;
        timestamps: PropTypes.Validator<PropTypes.InferProps<{
            current: PropTypes.Validator<number>;
            previous: PropTypes.Validator<number>;
        }>>;
        isSkipped: PropTypes.Validator<boolean>;
    };
    shouldComponentUpdate: typeof shouldPureComponentUpdate;
    render(): JSX.Element;
    handleButtonClick: (btn: Button, e: React.MouseEvent<HTMLDivElement, MouseEvent>) => void;
    handleMouseEnter: (e: React.MouseEvent<HTMLDivElement, MouseEvent>) => void;
    handleMouseEnterDebounced: ((buttons: any) => void) & import("lodash").Cancelable;
    handleMouseLeave: (() => void) & import("lodash").Cancelable;
    handleMouseDown: (e: React.MouseEvent<HTMLDivElement, MouseEvent>) => void;
}
export {};
