import { Action } from 'redux';
import { Props } from './DevtoolsInspector';
declare const UPDATE_MONITOR_STATE = "@@redux-devtools-inspector/UPDATE_MONITOR_STATE";
interface UpdateMonitorStateAction {
    type: typeof UPDATE_MONITOR_STATE;
    monitorState: Partial<MonitorState>;
}
export declare type MonitorAction = UpdateMonitorStateAction;
export interface MonitorState {
    readonly selectedActionId: number | null;
    readonly startActionId: number | null;
    readonly inspectedActionPath: (string | number)[];
    readonly inspectedStatePath: (string | number)[];
    readonly tabName: string;
    readonly searchValue?: string;
}
export declare const DEFAULT_STATE: MonitorState;
export declare function updateMonitorState(monitorState: Partial<MonitorState>): UpdateMonitorStateAction;
export declare function reducer<S, A extends Action<unknown>>(props: Props<S, A>, state: MonitorState | undefined, action: MonitorAction): {
    selectedActionId: number | null;
    startActionId: number | null;
    inspectedActionPath: (string | number)[];
    inspectedStatePath: (string | number)[];
    tabName: string;
    searchValue?: string | undefined;
};
export {};
